#define EBATWO
using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.XR;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using Object = UnityEngine.Object;
using System.Text.RegularExpressions;

namespace Cotyounoyume
{
    public class AddonClothSimItem : MonoBehaviour 
    {
		public Atom atom;
		public EBATCore core;
		private float lastTime;
		
		#region Undress
		public ClothesStateChanger csc;
		public bool isUndressActive = false;
		#endregion
		
		#region addon common
		public AddonClothSimItem(EBATCore core){
			atom = core.atom;
			this.core = core;
		}
		
		public void loadSettings(){
			try{
				
			}catch (Exception e){
				core.loggerE(e);
			}
		}
		
		public void applySettings(){
			BackupClothesState();
			
		}

		public void manage(float time){
		}	
		
		public void OnDestroy(){
		}
		
		public void OnOrgasmStart()
		{
		}
		
		public void OnOrgasmStop()
		{

		}
		#endregion

		#region ClothSim
		public void BackupClothesState(){
			try{
				if(csc != null){
					csc.OnDestroy();
				}
				csc = new ClothesStateChanger(core.atom);
//				csc.setTestCloth("TestCloth01");
			}catch(Exception e){
				core.loggerE(e);
			}			
		}
				
		public void Undress(string type){
			isUndressActive = true;
			core.setGauge(core.stageThreshold[2]);
			core.OnErogenousZoneTouch("Nipple");
			
			if(type == "Undress"){
				core.StartCoroutine(UndressCoroutine(1.0f, 5, false));
			}else if(type == "UndressHalf"){
				core.StartCoroutine(UndressCoroutine(0.7f, 5, false));
			}else if(type == "Reverse"){
				core.StartCoroutine(ReverseGravityCoroutine(2.0f, 12, false, false));
			}else if(type == "UndressAndReverse"){
				core.StartCoroutine(ReverseGravityCoroutine(2.0f, 12, false, true));				
			}else{
				core.debug("In Undress: Unknown Command: " + type);
			}
		}
		
		public void UndressStop(){
			try{
				isUndressActive = false;
				csc.UndressStop();
			}catch(Exception e){
				core.loggerE(e);
			}			
		}
		
		public void RemoveClothes(){
			try{
				csc.RemoveClothes();
			}catch(Exception e){
				core.loggerE(e);
			}						
		}
		
		public void RemoveResetClothes(){
			try{
				csc.RemoveResetClothes();
			}catch(Exception e){
				core.loggerE(e);
			}						
		}
		
		public void RecoverClothesState(){
			try{
				isUndressActive = false;
				csc.Recover();
			}catch(Exception e){
				core.loggerE(e);
			}			
		}		
		
		public void ResetClothesState(){
			try{
				csc.Reset();
			}catch(Exception e){
				core.loggerE(e);
			}			
		}		

		public IEnumerator UndressCoroutine(float power, int seconds, bool enableStopping = false){
			int num = 10 * seconds;
			float ratio;
			for(int i = 0; i < num; i++){
				ratio = (float)((float)(num - i) / ((float)num)) * power;
				if(isUndressActive){
					csc.Change("Undress", ratio);
					yield return new WaitForSeconds(0.1f);
				}
			}
			if(enableStopping){
				csc.Change("Undress", 0f);
			}
			isUndressActive = false;
		}
		
		public IEnumerator ReverseGravityCoroutine(float power, int seconds, bool enableStopping = false, bool enableUndress = false){
			int num = 10 * seconds;
			float ratio;
			for(int i = 0; i < num; i++){
				ratio = (float)((float)(num - i) / ((float)num)) * power;
				ratio = ratio * UnityEngine.Random.Range(0.5f, 1.0f);
				if(isUndressActive){
					if(enableUndress){
						csc.Change("UndressAndReverse", ratio);						
					}else{
						csc.Change("Reverse", ratio);
					}
					yield return new WaitForSeconds(0.1f);
				}
			}
			if(enableStopping){
				csc.Change("Reverse", 0f);
			}
			isUndressActive = false;
		}
		#endregion
	}
}