//#define EBATWO
//#define ADDON2
using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.XR;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace Cotyounoyume
{
    public class WorldUI
    {
		#region Define vars
		public Atom UIAtom;
		public EBATCore core;
		public CustomUI customUi;
		
        MVRScript plugin;
		WorldUIAddon1 worldUIAddon1;
		
#if	(ADDON2)	
		WorldUIAddon2 worldUIAddon2;
#endif
		
		private float xSpacing = 0.3f;
		private float xIndent = 0.1f;
		private float ySpacing = -0.05f;
		private float xOffset = 0.05f;
		private float yOffset = -0.08f;
        private float UIScale;

        public Canvas canvas;
		public Vector3 canvasPos;
		public Quaternion canvasRot;
		public UIDynamicButton uiMinimizeMenu;
		public UIDynamicButton uiCloseMenu;
		public UIDynamicButton uiOpenAtomMenu;
		public UIDynamicButton uiCloseUI;

		public UIDynamicButton uiOrgasmButton;
		public UIDynamicButton uiPeeButton;
		public UIDynamicButton uiResetExpressionButton;
		public UIDynamicButton uiCalmDownButton;
		
		public UIDynamicButton uiSoundOnButton;
		public UIDynamicButton uiEyesControlOnButton;
		public UIDynamicButton uiTearsOnButton;
		public UIDynamicButton uiExpressionOnButton;
		public UIDynamicButton uiBlushingOnButton;

		public UIDynamicButton uiDroolOnButton;			
		public UIDynamicButton uiEyesRollupOnButton;		
		public UIDynamicButton uiNippleErectionOnButton;	
		public UIDynamicButton uiClitorisErectionOnButton;
		public UIDynamicButton uiPeeingOnButton;			
		                       								
		public UIDynamicButton uiAutoExpressionOnButton;	
		public UIDynamicButton uiAutoBlinkOnButton;		
		
		public UIDynamicSlider uiStrengthSlider;
		public UIDynamicSlider uiWaveSlider;
		public UIDynamicSlider uiGaugeSlider;
		
		public float buttonSizeX = 200f;
		public float buttonSizeY = 40f;
		public float toggleSizeX = 200f;
		public float toggleSizeY = 40f;
		public float sliderSizeX = 500f;
		public float sliderSizeY = 80f;
		
		public string strMinimizeMenu = "Minimize This Menu";
		public string strMinimizeMenuAlt = "O";
		public string strOpenAtomMenu = "Open Atom UI";
		public string strCloseUI = "Close UI";

		public string strOrgasmButton    = "Make Her Orgasm";
		public string strOrgasmButtonAlt = "Stop Her Orgasm";
		public string strOrgasmButtonVar = "";
		public string strMaximinzeEcstasy = "Maximize Ecstasy";
		
		public string strPeeButton    = "Make Her Squirt";
		public string strCalmDownButton    = "Calm Her Down";
		public string strResetExpressionButton    = "Reset Expression";
		
		public string strStrengthSlider = "Expression Strength";
		public string strWaveSlider = "Cycles of Orgasm(Max)";
		public string strGaugeSlider = "Ecstasy Level";
		
		public string strCloseMenu    = "Close This Menu";

/*		
		public string strSoundOn = "Sound";
		public string strEyesControlOn = "EyesControl";
		public string strTearsOn = "Tears";
		public string strExpressionOn = "Expression";
		public string strBlushingOn = "Blushing";
*/		
		public string strSoundOnButtonVar;
		public string strEyesControlOnButtonVar;
		public string strTearsOnButtonVar;
		public string strExpressionOnButtonVar;
		public string strBlushingOnButtonVar;
		
		public string strDroolOnButtonVar;
		public string strEyesRollupOnButtonVar;
		public string strNippleErectionOnButtonVar;
		public string strClitorisErectionOnButtonVar;
		public string strPeeingOnButtonVar;
		              
		public string strAutoExpressionOnButtonVar;
		public string strAutoBlinkOnButtonVar;

		public string strSoundOnButtonOn = "Sound[ON]";
		public string strEyesControlOnButtonOn = "EyesControl[ON]";
		public string strTearsOnButtonOn = "Tears[ON]";
		public string strExpressionOnButtonOn = "Expression[ON]";
		public string strBlushingOnButtonOn = "Blushing[ON]";

		public string strDroolOnButtonOn = "Drool[ON]";
		public string strEyesRollupOnButtonOn = "EyesRollup[ON]";
		public string strNippleErectionOnButtonOn = "NippleErection[ON]";
		public string strClitorisErectionOnButtonOn = "ClitorisErection[ON]";
		public string strPeeingOnButtonOn = "Peeing[ON]";
		              
		public string strAutoExpressionOnButtonOn = "AutoExprOFF[ON]";
		public string strAutoBlinkOnButtonOn = "AutoBlinkOFF[ON]";

		public string strSoundOnButtonOff = "Sound[  ]";
		public string strEyesControlOnButtonOff = "EyesControl[  ]";
		public string strTearsOnButtonOff = "Tears[  ]";
		public string strExpressionOnButtonOff = "Expression[  ]";
		public string strBlushingOnButtonOff = "Blushing[  ]";
		
		public string strDroolOnButtonOff = "Drool[  ]";
		public string strEyesRollupOnButtonOff = "EyesRollup[  ]";
		public string strNippleErectionOnButtonOff = "NippleErection[  ]";
		public string strClitorisErectionOnButtonOff = "ClitorisErection[  ]";
		public string strPeeingOnButtonOff = "Peeing[  ]";
		              
		public string strAutoExpressionOnButtonOff = "AutoExpression[  ]";
		public string strAutoBlinkOnButtonOff = "AutoBlink[  ]";
		
		public int lineTop = 0;
		public int lineGaugeRelative = 1;
		public int lineMainFeatureRelative1 = 2;
		public int lineMainFeatureRelative2 = 3;
		public int lineMainFeatureRelative3 = 4;
		public int lineExpressionStrength = 6;
		public int lineGauge = 8;
		public int lineWaveCount = 10;
		public int lineMainLast;
		#endregion
		
		#region common
        public WorldUI(EBATCore core, float scale = 0.002f)
        {
            this.plugin = core as MVRScript;
            this.UIScale = scale;
			this.core = core;
			this.canvasPos = new Vector3(0f, 0f, 0f);
			this.canvasRot = new Quaternion(0f, 0f, 0f, 0f);
			this.lineMainLast = lineWaveCount;
        }
		
		public void loadSettings(){
			try{
				this.customUi = core.customUi;
			}catch(Exception e){
				core.loggerE(e);
			}
		}
		
		public void applySettings(){
			try{
				strOrgasmButtonVar = (core.isDuringOrgasm || core.isDuringAfterglow) ? strOrgasmButtonAlt : strOrgasmButton;

				worldUIAddon1 = new WorldUIAddon1(this);
				DoWorldUIAddon2Function("Construct");
			}catch(Exception e){
				core.loggerE(e);
			}
		}
		
		public void SetCanvasPosition(){
			canvasPos.x = customUi.jsCanvasPositionX.val;
			canvasPos.y = customUi.jsCanvasPositionY.val;
			canvasPos.z = customUi.jsCanvasPositionZ.val;
			
			canvasRot.x = customUi.jsCanvasRotationX.val;
			canvasRot.y = customUi.jsCanvasRotationY.val;
			canvasRot.z = customUi.jsCanvasRotationZ.val;
			canvasRot.w = customUi.jsCanvasRotationW.val;
		}
		
		public void OnDestroy()
		{
			RemoveMenuBody();
			worldUIAddon1.RemoveMenuBodyAddon();
			DoWorldUIAddon2Function("RemoveMenuBodyAddon");
			RemoveMenuBase();
		}
		#endregion
				
		#region Make Base UI
		public void makeWorldUI(){
			MakeMenuBase();
			MakeMenuBody();
		}

		public void RemoveMenuAll(){
			RemoveMenuBody();
		}
		
		public void RemoveMenuBase(){
			if (UIAtom != null){
				SuperController.singleton.RemoveAtom(UIAtom);
			}
			if (SuperController.singleton != null){
				SuperController.singleton.RemoveCanvas(canvas);
			}			
		}
		
		public void MakeMenuBase(){
			Vector3 headPosition = Utility.getPositionFromTargetBodyname(core.atom, "headControl");
			
			if(customUi.jsCanvasPositionX.val == 0f){
				canvasPos = Utility.getPosition(headPosition);
				canvasPos.x = canvasPos.x + -0.5f;					
			}else{
				SetCanvasPosition();
			}				

			if(UIAtom == null){
				MakeCanvas();
				
				core.StartCoroutine(core.CreateAtom("Empty", "UI", (tmpatom)=>
				{
					UIAtom = tmpatom;
					UIAtom.mainController.transform.position = Utility.getPosition(canvasPos);
					UIAtom.mainController.transform.rotation = Utility.getRotation(canvasRot);
					canvas.transform.SetParent(UIAtom.mainController.transform, false);
				}));
			}
		}
		
		public void MakeCanvas(){
            GameObject canvasObject = new GameObject();
            canvas = canvasObject.AddComponent<Canvas>();
            canvas.renderMode = RenderMode.WorldSpace;
            canvas.pixelPerfect = false;
            SuperController.singleton.AddCanvas(canvas);

            CanvasScaler cs = canvasObject.AddComponent<CanvasScaler>();
            cs.scaleFactor = 100.0f;
            cs.dynamicPixelsPerUnit = 1f;

            GraphicRaycaster gr = canvasObject.AddComponent<GraphicRaycaster>();

            canvas.transform.localScale = new Vector3(this.UIScale, this.UIScale, this.UIScale);
			Utility.LookFront(canvas.transform);			
		}
		#endregion
		
		#region Make UI Body
		public void MakeMenuBody(){
			MakeMenuBodyMain();
			Coloring();
			worldUIAddon1.MakeMenuBodyAddon();
			DoWorldUIAddon2Function("MakeMenuBodyAddon");
		}
		
		public void MakeMenuBodyMain(){
			try{
				#region DrawMainUI
				//orgasm class relatives
				if(core.orgasmModeOn){
					uiOrgasmButton = MakeButton(strOrgasmButtonVar, 0, lineGaugeRelative);
				}else{
					uiOrgasmButton = MakeButton(strMaximinzeEcstasy, 0, lineGaugeRelative);					
				}
				uiOrgasmButton.button.onClick.AddListener(OnOrgasmButtonClick);
#if	(EBATWO)	
				uiWaveSlider = MakeSlider(strWaveSlider, 0, lineWaveCount, 0f, 1000f, core.orgasm.orgasmWaveCycleBigMax);
				uiWaveSlider.slider.onValueChanged.AddListener(OnWaveSliderChange);
#endif

				//normal main
				//buttons
				uiMinimizeMenu = MakeButton(strMinimizeMenu, 0, lineTop);
				uiCloseMenu = MakeButton(strCloseMenu, 1, lineTop);
				uiOpenAtomMenu = MakeButton(strOpenAtomMenu, 2, lineTop);
				uiCloseUI = MakeButton(strCloseUI, 3, lineTop);
				
				uiPeeButton = MakeButton(strPeeButton, 1, lineGaugeRelative);
				uiResetExpressionButton = MakeButton(strResetExpressionButton, 3, lineGaugeRelative);
				uiCalmDownButton = MakeButton(strCalmDownButton, 2, lineGaugeRelative);
				
				uiExpressionOnButton       = MakeButton(strExpressionOnButtonVar, 0, lineMainFeatureRelative1);
				uiBlushingOnButton         = MakeButton(strBlushingOnButtonVar, 1, lineMainFeatureRelative1);
				uiTearsOnButton            = MakeButton(strTearsOnButtonVar, 2, lineMainFeatureRelative1);
                uiDroolOnButton            = MakeButton(strDroolOnButtonVar, 3, lineMainFeatureRelative1);			

                uiAutoExpressionOnButton   = MakeButton(strAutoExpressionOnButtonVar, 0, lineMainFeatureRelative2);	
                uiAutoBlinkOnButton        = MakeButton(strAutoBlinkOnButtonVar, 1, lineMainFeatureRelative2);		
				uiEyesControlOnButton      = MakeButton(strEyesControlOnButtonVar, 2, lineMainFeatureRelative2);
                uiEyesRollupOnButton       = MakeButton(strEyesRollupOnButtonVar, 3, lineMainFeatureRelative2);		
				
				uiSoundOnButton            = MakeButton(strSoundOnButtonVar, 0, lineMainFeatureRelative3);
                uiPeeingOnButton           = MakeButton(strPeeingOnButtonVar, 1, lineMainFeatureRelative3);			
                uiNippleErectionOnButton   = MakeButton(strNippleErectionOnButtonVar, 2, lineMainFeatureRelative3);	
                uiClitorisErectionOnButton = MakeButton(strClitorisErectionOnButtonVar, 3, lineMainFeatureRelative3);
                								
				uiExpressionOnButton.button.onClick.AddListener(OnExpressionOnButtonClick);
				uiBlushingOnButton.button.onClick.AddListener(OnBlushingOnButtonClick);
				uiTearsOnButton.button.onClick.AddListener(OnTearsOnButtonClick);
                uiDroolOnButton.button.onClick.AddListener(OnDroolOnButtonClick);			

                uiAutoExpressionOnButton.button.onClick.AddListener(OnAutoExpressionOnButtonClick);
                uiAutoBlinkOnButton.button.onClick.AddListener(OnAutoBlinkOnButtonClick);
				uiEyesControlOnButton.button.onClick.AddListener(OnEyesControlOnButtonClick);
                uiEyesRollupOnButton.button.onClick.AddListener(OnEyesRollupOnButtonClick);
				
				uiSoundOnButton.button.onClick.AddListener(OnSoundOnButtonClick);
                uiPeeingOnButton.button.onClick.AddListener(OnPeeingOnButtonClick);		
                uiNippleErectionOnButton.button.onClick.AddListener(OnNippleErectionOnButtonClick);
                uiClitorisErectionOnButton.button.onClick.AddListener(OnClitorisErectionOnButtonClick);
                								
				/*
				uiEyesControlOn = MakeToggle(strEyesControlOn, 1, lineMainFeatureRelative);
				uiTearsOn       = MakeToggle(strTearsOn, 2, lineMainFeatureRelative);
				uiExpressionOn  = MakeToggle(strExpressionOn, 3, lineMainFeatureRelative);
				uiBlushingOn    = MakeToggle(strBlushingOn, 4, lineMainFeatureRelative);
				*/

				//sliders
				uiStrengthSlider = MakeSlider(strStrengthSlider, 0, lineExpressionStrength, 0f, 1.2f, core.expression.expressionStrengthBase);
				uiGaugeSlider = MakeSlider(strGaugeSlider, 0, lineGauge, 0f, 120f, (float)core.getGauge());				
				Image bgImage = uiGaugeSlider.GetComponentInChildren<Image>();
				bgImage.color = new Color(1f, 0.25f, 0.75f);
				uiGaugeSlider.labelText.color = new Color(1, 0, 0);
				#endregion
				
				#region DefineMainUI
				//buttons
				uiMinimizeMenu.button.onClick.AddListener(OnMinimizeMenuClick);
				uiCloseMenu.button.onClick.AddListener(OnCloseMenuClick);
				uiOpenAtomMenu.button.onClick.AddListener(OnOpenAtomMenuClick);
				uiCloseUI.button.onClick.AddListener(OnCloseUIClick);
				
				uiPeeButton.button.onClick.AddListener(OnPeeButtonClick);
				uiResetExpressionButton.button.onClick.AddListener(OnResetExpressionButton);
				uiCalmDownButton.button.onClick.AddListener(OnCalmDownButtonClick);
				//sliders
				uiStrengthSlider.slider.onValueChanged.AddListener(OnStrengthSliderChange);				
				#endregion
				
				LabelSwitch();
			}catch(Exception e){
				core.loggerE(e);
			}
		}

		public void RemoveMenuBody(){
			RemoveMenuBodyMain();
			worldUIAddon1.RemoveMenuBodyAddon();
			DoWorldUIAddon2Function("RemoveMenuBodyAddon");
		}

		public void Coloring(){
			UIDynamicButton[] buttons = {
				uiExpressionOnButton, uiBlushingOnButton, uiTearsOnButton, uiDroolOnButton,
				uiAutoExpressionOnButton, uiAutoBlinkOnButton, uiEyesControlOnButton, uiEyesRollupOnButton, 
				uiSoundOnButton, uiPeeingOnButton, uiNippleErectionOnButton, uiClitorisErectionOnButton,				
			};
			
			foreach(UIDynamicButton button in buttons){
				button.buttonColor = new Color(1f, 1f, 1f);
			}
		}
		
		public void RemoveMenuBodyMain(){
			UIDynamicButton[] buttons = {
				uiMinimizeMenu, uiCloseMenu, uiOpenAtomMenu, uiCloseUI, 
				uiResetExpressionButton, uiCalmDownButton, uiOrgasmButton, uiPeeButton, 
				uiExpressionOnButton, uiBlushingOnButton, uiTearsOnButton, uiDroolOnButton,
				uiAutoExpressionOnButton, uiAutoBlinkOnButton, uiEyesControlOnButton, uiEyesRollupOnButton, 
				uiSoundOnButton, uiPeeingOnButton, uiNippleErectionOnButton, uiClitorisErectionOnButton,				
			};

			UIDynamicSlider[] sliders = {
				uiStrengthSlider, uiWaveSlider, uiGaugeSlider
			};

			RemoveMenuBodyImpl(buttons, sliders);
		}

		public void RemoveMenuBodyImpl(UIDynamicButton[] buttons, UIDynamicSlider[] sliders){
			foreach(UIDynamicButton button in buttons){
				if(button != null){ plugin.RemoveButton(button);} 
			}
			
			foreach(UIDynamicSlider slider in sliders){
				if(slider != null){ Utility.RemoveSliderForCanvas(slider);}
			}			
		}
		#endregion
		
		#region Define UI Function Main
		public void OnOrgasmButtonClick(){
			if(core.orgasmModeOn == false){
				if(core.getGauge() < core.stageThreshold[5]){
					core.setGauge(core.stageThreshold[5]);
					core.OnErogenousZoneTouch("DeeperVagina");
					core.updateAll();
				}
			}else{
#if	(EBATWO)
				if(uiOrgasmButton.label == strOrgasmButton){
					if(core.getGauge() < core.stageThreshold[5]){
						core.setGauge(core.stageThreshold[5]);
						core.OnErogenousZoneTouch("DeeperVagina");
						core.updateAll();
					}
					core.orgasmFunctions("orgasmStart", 0f);					
				}else{
					core.setGauge(core.stageThreshold[0]);
					core.orgasmFunctions("orgasmFinish", 0f);						
				}
#endif				
			}
		}

		public void OnWaveSliderChange(float value){
#if	(EBATWO)
			core.orgasm.orgasmWaveCycleBigMax = (int)value;
//			core.customUi.jfOWCountBigMax.slider.value = value;
			core.customUi.dJSSlider["Orgasm Wave Big Cycle Count Max"].slider.value = value;
			core.saveConfig();			
#endif
		}
		
		public void OnCloseMenuClick(){
//			core.customUi.toggleUIMenu.SetVal(false);
			core.customUi.dJSToggle["Display UI Menu"].SetVal(false);
			RemoveMenuBody();
//			RemoveMenuAll();
		}

		public void OnMinimizeMenuClick(){
			canvasPos = Utility.getPosition(UIAtom.mainController.transform.position);
			RemoveMenuBody();
			uiMinimizeMenu = MakeButton(strMinimizeMenuAlt, 0, 0, width:40, height:40);
			uiMinimizeMenu.button.onClick.AddListener(ExpandMenu);
		}

		public void OnOpenAtomMenuClick(){
			Utility.OpenAtomUI(core.atom);
		}
		
		public void OnCloseUIClick(){
			Utility.CloseUI();
		}

		public void ExpandMenu(){
			plugin.RemoveButton(uiMinimizeMenu);
			MakeMenuBody();
		}

		public void OnPeeButtonClick(){
			if(core.unityAssets.peeingOnGlobal){
				if(core.getGauge() < core.stageThreshold[2]){
					core.setGauge(core.stageThreshold[2]);
					core.OnErogenousZoneTouch("DeeperVagina");						
				}
				core.unityAssets.peeRandom(core.getTime(), true);
			}
			DAZCharacterSelector character = core.atom.GetStorableByID("geometry") as DAZCharacterSelector;
			var ui = character.selectedCharacter.transform;			
		}

		public void OnResetExpressionButton(){
			core.expression.resetExpression();
		}

		public void OnCalmDownButtonClick(){
			core.orgasmFunctions("orgasmFinish", 0f);
			core.setGauge(0);
			core.tears.refreshTears();
			core.blushing.switchFaceDecal("");
			core.expression.resetExpression();			
		}
		
		public void LabelSwitch(){
			LabelVarChange();
			LabelUpdate();
		}
		
		public void LabelVarChange(){
			strSoundOnButtonVar = (core.sound.soundOnGlobal) ? strSoundOnButtonOn : strSoundOnButtonOff;
			strTearsOnButtonVar = (core.tears.tearsOnGlobal) ? strTearsOnButtonOn : strTearsOnButtonOff;
			strEyesControlOnButtonVar = (core.eyesControl.eyecontrolOnGlobal) ? strEyesControlOnButtonOn : strEyesControlOnButtonOff;
			strExpressionOnButtonVar = (core.expression.expressionOnGlobal) ? strExpressionOnButtonOn : strExpressionOnButtonOff;
			strBlushingOnButtonVar = (core.blushing.blushOnGlobal) ? strBlushingOnButtonOn : strBlushingOnButtonOff;
						
			strDroolOnButtonVar = (core.tears.droolOnGlobal) ? strDroolOnButtonOn : strDroolOnButtonOff;
			strEyesRollupOnButtonVar = (core.eyesControl.eyecontrolRollupOnGlobal) ? strEyesRollupOnButtonOn : strEyesRollupOnButtonOff;
			strNippleErectionOnButtonVar = (core.bodyMorph.nippleErectionOnGlobal) ? strNippleErectionOnButtonOn : strNippleErectionOnButtonOff;
			strClitorisErectionOnButtonVar = (core.bodyMorph.clitorisErectionOnGlobal) ? strClitorisErectionOnButtonOn : strClitorisErectionOnButtonOff;
			strPeeingOnButtonVar = (core.unityAssets.peeingOnGlobal) ? strPeeingOnButtonOn : strPeeingOnButtonOff;
						
			strAutoExpressionOnButtonVar = (core.etc.autoExpressionOffGlobal) ? strAutoExpressionOnButtonOn : strAutoExpressionOnButtonOff;
			strAutoBlinkOnButtonVar = (core.etc.autoBlinkOffGlobal) ? strAutoBlinkOnButtonOn : strAutoBlinkOnButtonOff;
		}
		
		public void LabelUpdate(){
			uiSoundOnButton.label			= strSoundOnButtonVar;
			uiTearsOnButton.label			= strTearsOnButtonVar;
			uiEyesControlOnButton.label		= strEyesControlOnButtonVar;
			uiExpressionOnButton.label		= strExpressionOnButtonVar;
			uiBlushingOnButton.label		= strBlushingOnButtonVar;
			uiDroolOnButton.label			= strDroolOnButtonVar;
			uiEyesRollupOnButton.label		= strEyesRollupOnButtonVar;
			uiNippleErectionOnButton.label	= strNippleErectionOnButtonVar;
			uiClitorisErectionOnButton.label= strClitorisErectionOnButtonVar;
			uiPeeingOnButton.label			= strPeeingOnButtonVar;
												
			uiAutoExpressionOnButton.label	= strAutoExpressionOnButtonVar;
			uiAutoBlinkOnButton.label		= strAutoBlinkOnButtonVar;
		}
		
		public void OnSoundOnButtonClick(){
			core.customUi.ToggleAny("Sound On");
			LabelSwitch();
		}
		
		public void OnTearsOnButtonClick(){
			core.customUi.ToggleAny("Tears On");
			LabelSwitch();
		}
		
		public void OnExpressionOnButtonClick(){
			core.customUi.ToggleAny("Expression On");
			LabelSwitch();
		}
		
		public void OnBlushingOnButtonClick(){
			core.customUi.ToggleAny("Blush On");
			LabelSwitch();
		}
		
		public void OnEyesControlOnButtonClick(){
			core.customUi.ToggleAny("Eyes Control On");
			LabelSwitch();
		}
		
		public void OnDroolOnButtonClick(){
			core.customUi.ToggleAny("Drool On");
			LabelSwitch();
		}
		
		public void OnEyesRollupOnButtonClick(){
			core.customUi.ToggleAny("Eyes Rollup On");
			LabelSwitch();
		}
		
		public void OnNippleErectionOnButtonClick(){
			core.customUi.ToggleAny("Nipple Erection On");
			LabelSwitch();
		}
		
		public void OnClitorisErectionOnButtonClick(){
			core.customUi.ToggleAny("Clitoris Erection On");
			LabelSwitch();
		}
		
		public void OnPeeingOnButtonClick(){
			try{
			core.customUi.ToggleAny("Peeing On");
			LabelSwitch();
				
			}catch(Exception e){
				core.loggerE(e);
			}
		}
		
		public void OnAutoExpressionOnButtonClick(){
			core.customUi.ToggleAny("Auto Expression Off");
			LabelSwitch();
		}
		
		public void OnAutoBlinkOnButtonClick(){
			core.customUi.ToggleAny("Auto Blink Off");
			LabelSwitch();
		}
				
		public void OnStrengthSliderChange(float value){
			core.expression.expressionStrengthBase = value;
//			core.customUi.jfExpressionStrength.slider.value = value;
			core.customUi.dJSSlider["Expression Strength"].slider.value = value;
			core.saveConfig();			
		}

		public void OnOrgasmStart()
		{
			if(core.orgasmModeOn){
				strOrgasmButtonVar = strOrgasmButtonAlt;
				uiOrgasmButton.label = strOrgasmButtonVar;
			}
		}
		
		public void OnOrgasmStop()
		{
			if(core.orgasmModeOn){
				strOrgasmButtonVar = strOrgasmButton;
				uiOrgasmButton.label = strOrgasmButtonVar;
			}
		}
		#endregion
		
		#region Define Alias
		public UIDynamicButton MakeButton(string name, int x, int y, float width = 0f, float height = 0f){
			width  = (width  == 0f) ? buttonSizeX : width;
			height = (height == 0f) ? buttonSizeY : height;			
			UIDynamicButton uiButton = Utility.CreateButton(plugin, canvas, name, width, height);
			Utility.TranslateUI(uiButton, xOffset + xSpacing * x, yOffset + ySpacing * y);
			return uiButton;
		}
		
		public UIDynamicButton MakeButtonForAddon(string name, int x, int y, float width = 0f, float height = 0f){
			float xpos = xIndent + xOffset + xSpacing * x;
			float ypos = yOffset + ySpacing * y;
			width  = (width  == 0f) ? buttonSizeX : width;
			height = (height == 0f) ? buttonSizeY : height;			
			if(x == -1){
				xpos = xOffset;
				width = xIndent;
			}
			UIDynamicButton uiButton = Utility.CreateButton(plugin, canvas, name, width, height);
			Utility.TranslateUI(uiButton, xpos, ypos);
			return uiButton;
		}		
		
		public UIDynamicToggle MakeToggle(string name, int x, int y, float width = 0f, float height = 0f){
			try{
			width  = (width  == 0f) ? toggleSizeX : width;
			height = (height == 0f) ? toggleSizeY : height;			
			UIDynamicToggle uiToggle = Utility.CreateToggle(plugin, canvas, name, width, height);
			Utility.TranslateUI(uiToggle, xOffset + xSpacing * x, yOffset + ySpacing * y);
			return uiToggle;
				
			}catch(Exception e){
				core.loggerE(e);
				return null;
			}
		}
		
		public UIDynamicSlider MakeSlider(string name, int x, int y, float min, float max, float current){
			UIDynamicSlider uiSlider = Utility.CreateSliderAlt(plugin, canvas, name, sliderSizeX, sliderSizeY, min, max, current, true);
			Utility.TranslateUI(uiSlider, xOffset + xSpacing * x, yOffset + ySpacing * y);
			return uiSlider;
		}
		
		public void DoWorldUIAddon2Function(string func){
#if	(ADDON2)
			if(func == "Construct"){
				this.worldUIAddon2 = new WorldUIAddon2(this);
			}else if(func == "RemoveMenuBodyAddon"){
				worldUIAddon2.RemoveMenuBodyAddon();
			}else if(func == "MakeMenuBodyAddon"){
				worldUIAddon2.MakeMenuBodyAddon();				
			}else{
				core.debug("In WorldUI: Unknown command: " + func);
			}
#endif			
		}
		#endregion
	}
}
